#!/bin/bash

# mkdir -p /opt/docker-run/redis && curl -o /opt/docker-run/redis/redis.sh https://git.zykeji.club/open/server-init/raw/master/Docker/run/redis.sh && sh /opt/docker-run/redis/redis.sh

read -r -p "请输入容器名称(默认: redis): " redisName
redisName=${redisName:-redis}

read -r -p "请输入外部访问端口号(默认: 6379): " port
port=${port:-6379}

read -r -p "请输入绑定的IP地址(默认: 0.0.0.0): " host
host=${host:-"0.0.0.0"}

read -r -p "请输入密码(默认: 123456): " password
password=${password:-"123456"}

echo "创建脚本存放目录和数据"
mkdir -p /opt/docker-run/redis/data
mkdir -p /opt/docker-run/redis/conf

echo "创建Redis配置文件"
touch /opt/docker-run/redis/conf/redis.conf
echo "清空旧配置"
cat /dev/null > /opt/docker-run/redis/conf/redis.conf
echo "写入新配置"
cat <<EOF >> /opt/docker-run/redis/conf/redis.conf
bind $host
daemonize NO
protected-mode no
requirepass $password
EOF

echo "拉取镜像"
docker pull redis:latest
echo "运行容器"
echo "docker run -d --name $redisName -p $port:6379 -v /opt/docker-run/redis/data:/data -v /opt/docker-run/redis/conf:/usr/local/etc/redis redis"
docker run -d --name $redisName -p $port:6379 -v /opt/docker-run/redis/data:/data -v /opt/docker-run/redis/conf/redis.conf:/etc/redis/redis.conf redis redis-server /etc/redis/redis.conf --appendonly yes

echo "脚本执行完成"

